precision mediump float;
uniform sampler2D uRainSampler;
uniform sampler2D uBackgroundSampler;
uniform sampler2D uForegroundSampler;
uniform vec2 uOOSurfaceSize;
uniform vec2 uRainTexCoordScale;
uniform vec2 uRainTexCoordOffset;
uniform vec4 uTint;
varying vec2 vTexCoord;
void main ()
{
  lowp vec3 raindropColor_1;
  lowp vec4 rainSample_2;
  lowp vec4 tmpvar_3;
  tmpvar_3 = texture2D (uRainSampler, ((vTexCoord * uRainTexCoordScale) + uRainTexCoordOffset));
  rainSample_2.xyz = (tmpvar_3.xyz / tmpvar_3.w);
  rainSample_2.w = clamp (((tmpvar_3.w * 6.0) - 3.0), 0.0, 1.0);
  raindropColor_1 = (texture2D (uForegroundSampler, (vTexCoord + (
    (uOOSurfaceSize * ((rainSample_2.yx - 0.5) * 2.0))
   * 
    mix (128.0, 512.0, rainSample_2.z)
  ))).xyz * 1.04);
  raindropColor_1 = (raindropColor_1 + (uTint.xyz * dot (vec3(0.2126, 0.7152, 0.0722), raindropColor_1)));
  lowp vec4 tmpvar_4;
  tmpvar_4 = texture2D (uBackgroundSampler, vTexCoord);
  lowp vec3 tmpvar_5;
  tmpvar_5 = (tmpvar_4.xyz + (rainSample_2.w * (raindropColor_1 - tmpvar_4.xyz)));
  mediump vec4 tmpvar_6;
  tmpvar_6.w = 1.0;
  tmpvar_6.xyz = tmpvar_5;
  gl_FragColor = tmpvar_6;
}

