precision mediump float;
uniform sampler2D uBackgroundSampler;
uniform sampler2D uOverlaySampler;
uniform float uOverlayAlpha;
varying vec2 vTexCoord;
void main ()
{
  lowp vec4 tmpvar_1;
  tmpvar_1.w = 1.0;
  tmpvar_1.xyz = (texture2D (uBackgroundSampler, vTexCoord).xyz + (texture2D (uOverlaySampler, vTexCoord).xyz * uOverlayAlpha));
  gl_FragColor = tmpvar_1;
}

