precision mediump float;
uniform sampler2D uRainSampler;
uniform sampler2D uBackgroundSampler;
uniform sampler2D uForegroundSampler;
uniform vec2 uOOSurfaceSize;
uniform vec2 uRainTexCoordScale;
uniform vec2 uRainTexCoordOffset;
varying vec2 vTexCoord;
void main ()
{
  lowp vec4 rainSample_1;
  lowp vec4 tmpvar_2;
  tmpvar_2 = texture2D (uRainSampler, ((vTexCoord * uRainTexCoordScale) + uRainTexCoordOffset));
  rainSample_1.xyz = (tmpvar_2.xyz / tmpvar_2.w);
  rainSample_1.w = clamp (((tmpvar_2.w * 6.0) - 3.0), 0.0, 1.0);
  lowp vec4 tmpvar_3;
  tmpvar_3 = texture2D (uBackgroundSampler, vTexCoord);
  lowp vec3 tmpvar_4;
  tmpvar_4 = (tmpvar_3.xyz + (rainSample_1.w * (
    (texture2D (uForegroundSampler, (vTexCoord + ((uOOSurfaceSize * 
      ((rainSample_1.yx - 0.5) * 2.0)
    ) * mix (128.0, 512.0, rainSample_1.z)))).xyz * 1.04)
   - tmpvar_3.xyz)));
  mediump vec4 tmpvar_5;
  tmpvar_5.w = 1.0;
  tmpvar_5.xyz = tmpvar_4;
  gl_FragColor = tmpvar_5;
}

